#import "TAAboutPanelController.h"

@implementation TAAboutPanelController

+ (id) sharedController
{
	static TAAboutPanelController *sharedInstance = nil;
	
	if(!sharedInstance)
	{
		sharedInstance = [[TAAboutPanelController alloc] init];
	}
	return sharedInstance;
}

- (id) init
{
	return [super initWithWindowNibName: @"About" owner: self];
}

- (void)windowDidLoad 
{
	const double TextAdditionsVersionNumber = 0.2;
	NSString *readMePath;
	
	[super windowDidLoad];
	[versionField setStringValue:
		[NSString stringWithFormat:[versionField stringValue],
			TextAdditionsVersionNumber]];
	
	readMePath = [[NSBundle bundleForClass:[self class]]
		pathForResource: @"About" ofType: @"rtf"];
		
	if (readMePath)
	{
		[textView replaceCharactersInRange:
			NSMakeRange(0, [[textView string] length])
			withRTF: [NSData dataWithContentsOfFile:readMePath]];
		[textView scrollRangeToVisible: NSMakeRange(0, 0)];
	}
}

- (void)showWindow: (id)sender
{
	[[self window] center];
	[super showWindow: sender];
}

@end
