#import "TA_NSDictionaryExtensions.h"

@implementation NSDictionary(TAWebObjectsOutput)

- (NSString *) actionDeclaration
{
	return [NSString stringWithFormat:
		@"\n- (WOComponent *) %@\n{\n\tWOComponent *page;\n\n"
		@"\tpage = [self pageWithName:@\"NAME_GOES_HERE\"];\n\n"
		@"\t//Insert Your code here\n\n"
		@"\treturn page;\n}\n",
		[self objectForKey: @"action"]];
}

- (NSString *) variableDeclarations
{
	NSMutableArray *keys;
	NSEnumerator *keyEnumerator;
	NSString *key;
	NSMutableString *outputString;
	NSAutoreleasePool *pool;
	
	pool = [[NSAutoreleasePool alloc] init];
	
	keys = [[NSMutableArray alloc] initWithArray: [self allKeys]];
	[keys removeObject: @"WOBindingName"];
	[keys removeObject: @"WOTagName"];

	outputString = [[NSMutableString alloc] init];
	
	keyEnumerator = [keys objectEnumerator];
	
	while((key = [keyEnumerator nextObject]))
	{
		if([key isEqualToString: @"list"])
		{
			[outputString appendFormat:@"NSArray *%@;\n",
				[self objectForKey: key]];
		}
		else if([key isEqualToString:@"item"] ||
			[key hasPrefix:@"selection"] ||
			([key isEqualToString:@"value"] && 
				![[self objectForKey: @"WOTagName"]
					isEqualToString:@"WOSubmitButton"] &&
				![[self objectForKey: @"WOTagName"]
					isEqualToString:@"WOResetButton"]))
		{
			[outputString appendFormat:@"id %@;\n",
				[self objectForKey: key]];
		}
	}
	
	[keys release];
	[pool release];
	return [outputString autorelease];
}


- (NSString *) descriptionAsWod
{
	NSMutableArray *keys;
	NSEnumerator *keyEnumerator;
	NSString *key;
	NSMutableString *outputString;
	NSAutoreleasePool *pool;
	
	pool = [[NSAutoreleasePool alloc] init];
	
	keys = [[NSMutableArray alloc] initWithArray: [self allKeys]];
	[keys removeObject: @"WOBindingName"];
	[keys removeObject: @"WOTagName"];

	outputString = [[NSMutableString alloc] init];
	[outputString appendFormat:@"%@ : %@\n{\n",
		[self objectForKey:@"WOBindingName"],
		[self objectForKey: @"WOTagName"]];
	
	keyEnumerator = [keys objectEnumerator];
	
	while((key = [keyEnumerator nextObject]))
	{
		if([key isEqualToString: @"list"] || [key isEqualToString:@"item"] ||
			[key hasPrefix:@"selection"] ||
			[key isEqualToString:@"action"] ||
			([key isEqualToString:@"value"] && 
				![[self objectForKey: @"WOTagName"]
					isEqualToString:@"WOSubmitButton"] &&
				![[self objectForKey: @"WOTagName"]
					isEqualToString:@"WOResetButton"]))
		{
			[outputString appendFormat:@"\t%@ = %@;\n",
				key, [self objectForKey: key]];
		}
		else
		{
			[outputString appendFormat:@"\t%@ = \"%@\";\n",
				key, [self objectForKey: key]];
		}
	}
	
	[outputString appendFormat:@"}\n\n"];
	[keys release];
	[pool release];
	return [outputString autorelease];
}

@end
